> ## Documentation Index > Fetch the complete documentation index at: https://support.keypro.fi/llms.txt > Use this file to discover all available pages before exploring further. # Get list of Apartments > Operation is used to get a list of Apartments. Available from product version 3.0.22. Apartments can be filtered by giving filtering parameters at HTTP querystring (see parameters). ## OpenAPI ````json GET /apartments/ { "openapi": "3.0.4", "info": { "title": "KeyLight REST API", "termsOfService": "https://www.keypro.fi/en/terms-of-service", "contact": { "name": "Keypro Oy", "url": "https://keypro.fi/", "email": "keypro@keypro.fi" }, "license": { "name": "Copyright (C) Keypro Oy. All rights reserved.", "url": "https://www.keypro.fi/" }, "version": "2.0.0" }, "servers": [ { "url": "/api/v2" } ], "tags": [ { "name": "Plan", "description": "Plan related operations." }, { "name": "FreeArea", "description": "FreeArea related operations." }, { "name": "FreeLine", "description": "FreeLine related operations." }, { "name": "FreeText", "description": "FreeText related operations." }, { "name": "FreeTextComponent", "description": "FreeText component related operations." }, { "name": "Address", "description": "Building address related operations." }, { "name": "Apartment", "description": "Building apartments related operations." }, { "name": "Extra Attribute", "description": "Extra attributes related operations." }, { "name": "Extra Value", "description": "Extra attribute values related operations." }, { "name": "EAV Enum", "description": "EAV Enum value related operations." }, { "name": "EAV Enum Group", "description": "EAV Enum group related operations." }, { "name": "External Document", "description": "External documents related operations." }, { "name": "Attached Document", "description": "Attached Documents related operations." }, { "name": "Collections", "description": "Collection related operations." }, { "name": "Source system apartment", "description": "External source system derived apartment related operations." }, { "name": "Source system address", "description": "External source system derived address related operations." }, { "name": "Address alias", "description": "Address aliases related operations" }, { "name": "TxtConstant", "description": "TxtConstants related operations." }, { "name": "Point", "description": "Point objects related operations." }, { "name": "Survey Constant", "description": "Survey Constants related operations." }, { "name": "Survey Point", "description": "Survey Points related operations." }, { "name": "Survey Line String", "description": "Survey Line Strings related operations." }, { "name": "Template Catalog", "description": "Template Catalog related operations." }, { "name": "Route Following", "description": "Route following related operations." }, { "name": "Contact Person", "description": "Contact person related operations." }, { "name": "Contact Person Connection", "description": "Contact person connection related operations." }, { "name": "Electric Premises", "description": "Electric Premises related operations." }, { "name": "Electric Fuse", "description": "Fuse related operations." }, { "name": "Electric Splice", "description": "Electric Splice related operations." }, { "name": "Electric Manhole", "description": "Electric Manhole related operations." }, { "name": "Electric Point Object", "description": "Other electric point objects related operations." }, { "name": "Electric Pole", "description": "Electric Pole related operations." }, { "name": "Streetlight", "description": "Streetlight related operations." }, { "name": "Traffic Signal", "description": "Traffic signal related operations." }, { "name": "Electric Cable", "description": "Electric Cable related operations." }, { "name": "Electric Cable Connection", "description": "Operations related to connecting Electric Cables and Electric endpoints(Streetlights, Splices, Premises)." }, { "name": "Electric Conduit", "description": "Electric Conduit related operations." }, { "name": "Electric Conduit Link", "description": "Operations related to putting Electric Cables and Ducts into Conduits." }, { "name": "Electric Conduit Connection", "description": "Operations related to connecting Conduits and endpoints(Streetlights, Splices, Premises)." }, { "name": "Electric Duct", "description": "Electric Duct related operations." }, { "name": "Electric Duct Link", "description": "Operations related to putting Electric Cables into Ducts." }, { "name": "Electric Routefollower", "description": "Electric Routefollower related operations." }, { "name": "Task", "description": "Task related operations." }, { "name": "Subregion", "description": "Subregion related operations." }, { "name": "SAttribute", "description": "SAttribute related operations." }, { "name": "Fault", "description": "Fault related operations." }, { "name": "Maintenance history", "description": "Maintenance history related operations." }, { "name": "Deflection", "description": "Deflection related operations." }, { "name": "Fault Component", "description": "Fault Component related operations." }, { "name": "Task Comment", "description": "Task comment related operations." }, { "name": "FaultComponentFault", "description": "FaultComponentFault related operations." } ], "paths": { "/apartments/": { "get": { "tags": [ "Apartment" ], "summary": "Get list of Apartments", "description": "Operation is used to get a list of Apartments. Available from product version 3.0.22.\n\nApartments can be filtered by giving filtering parameters at HTTP querystring (see parameters).\n", "operationId": "getApartments", "parameters": [ { "$ref": "#/components/parameters/offsetParam" }, { "$ref": "#/components/parameters/limitParam" }, { "$ref": "#/components/parameters/srsParam" }, { "$ref": "#/components/parameters/precisionParam" }, { "$ref": "#/components/parameters/dimsParam" }, { "$ref": "#/components/parameters/filterParam" }, { "$ref": "#/components/parameters/orderParam" } ], "responses": { "200": { "description": "A result response object.", "content": { "application/json": { "schema": { "type": "object", "properties": { "Next": { "type": "string", "description": "Url to next page of Apartments. Null if No next page exist", "format": "url" }, "Previous": { "type": "string", "description": "Url to previous page of Apartments. Null if No previous page exist", "format": "url" }, "Results": { "type": "array", "items": { "$ref": "#/components/schemas/Apartment" }, "description": "List of fetched Apartments" }, "Total": { "type": "integer", "description": "Total number of Apartments" } } } } } }, "401": { "$ref": "#/components/responses/Http401" } }, "security": [ { "Token": [] } ] } } }, "components": { "parameters": { "offsetParam": { "name": "offset", "in": "query", "description": "Offset to start returning results.", "schema": { "minimum": 0, "type": "integer" } }, "limitParam": { "name": "limit", "in": "query", "description": "Limit number of results returned. Set to -1 to use maximum limit set in the environment. Default limit will be used if parameter is not specified. Special value -1 is available from product version 3.2.18.", "schema": { "minimum": 1, "type": "integer" } }, "srsParam": { "name": "srs", "in": "query", "description": "Coordinate system used to transform location fields in API responses.\nThis parameter does not apply to locations sent in request query parameters or request bodies.\n\nFor locations in requests, use EWKT with SRID.\nIf EWKT is provided without SRID, the system default SRID will be used.\n\n**Example:** `srs=epsg:4326`\n", "schema": { "type": "string" } }, "precisionParam": { "name": "precision", "in": "query", "description": "Number of decimals to be returned with object location. If parameter is not specified the number of decimals is as precise as possible for current running instance. Available from product version 2024.4.", "schema": { "minimum": 1, "type": "integer" } }, "dimsParam": { "name": "dimensions", "in": "query", "description": "number of dimensions to be returned. Acceptable values are 2 and 3. If parameter is not specified the number of dimensions are as default for current product. Available from product version 2024.4.", "schema": { "minimum": 1, "type": "integer" } }, "filterParam": { "name": "__any of the object fields__", "in": "query", "description": "Filters list by selected object field value.\nSupports structured queries via +++__+++ delimiter.\nSupports ending keywords via +++__+++ delimiter:\n- For string fields: istartswith, startswith, iendswith, endswith, contains, icontains, isnull\n- For numerics: gt, lt, gte, lte, isnull\n- For spatial fields: contains, isnull, within, intersects, disjoint, touches, overlaps, covers, coveredby\n**Examples:** `+++usage_state__txt__istartswith=in+++` ,\n`+++plan__state__txt__startswith=In+++` , `+++creation_date__gte=2019-01-02T15:32:01+++`,\n`+++location__within=POLYGON ((641503.89 6944059.81, 641406.52 6943933.87, 641369.48 6943772.48, 641474.25 6943704.74, 641873.78 6943735.96, 641848.38 6943975.15, 641607.08 6944167.76, 641653.11 6944102.15, 641503.89 6944059.81))+++`\nSupports exclusive queries by field value using a not-operator preceding the field lookup:\n**Examples:** `+++not__type__txt__istartswith=Tie+++` , `+++not__id=1390+++`\n", "schema": { "type": "string" } }, "orderParam": { "name": "orderby", "in": "query", "description": "Selects the object field to order the returned objects by.\nCan be used to sort in reverse order with '-' prefix.\nCan have several ordering rules separated by comma.\nCan be used only for object own fields and does not support structured queries.\n**Example:** `orderby=creator,-creation_date`\n", "schema": { "type": "string" } } }, "schemas": { "Apartment": { "required": [ "address" ], "type": "object", "properties": { "address": { "$ref": "#/components/schemas/Address" }, "apartmentDivision": { "type": "string", "description": "apartment division" }, "apartmentLetter": { "type": "string", "description": "apartment letter" }, "apartmentNumber": { "type": "string", "description": "apartment number" }, "empty": { "enum": [ 0, 1 ], "type": "integer", "description": "Apartment with this value as 1 is default apartment. Modifying or deleting such apartment is prohibited.", "readOnly": true }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "originProperty": { "type": "string", "description": "apartment original property id" }, "originalStreetno": { "type": "string", "description": "apartment original streen number" }, "sourceSystem": { "$ref": "#/components/schemas/SourceSystem" }, "sourceSystemKey": { "type": "integer", "description": "source system key" }, "usagePurpose": { "$ref": "#/components/schemas/ApartmentUsage" }, "usagePurposeAlt": { "$ref": "#/components/schemas/AddressSecondaryUsage" }, "usageState": { "$ref": "#/components/schemas/ApartmentStatus" } } }, "Address": { "required": [ "streetname", "city" ], "type": "object", "properties": { "buildingId": { "type": "string", "description": "Building id" }, "buildingName": { "type": "string", "description": "Building name" }, "city": { "type": "string", "description": "Building city name" }, "cityAlt": { "type": "string", "description": "Building city name in alternative language" }, "country": { "type": "string", "description": "Building country" }, "createdBy": { "type": "string", "description": "creator", "readOnly": true }, "createdTs": { "type": "string", "description": "Creation date and time", "format": "date-time", "readOnly": true }, "district": { "type": "string", "description": "Building district" }, "empty": { "enum": [ 0, 1 ], "type": "integer", "description": "Address with this value as 1 is default address. Modifying or deleting such address is prohibited.", "readOnly": true }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "location": { "type": "string", "description": "Geographical location", "format": "ewkt" }, "municipality": { "type": "string", "description": "Building municipality" }, "propertyId": { "type": "string", "description": "Property number" }, "province": { "type": "string", "description": "Building province" }, "sourceSystem": { "$ref": "#/components/schemas/SourceSystem" }, "sourceSystemKey": { "type": "integer", "description": "source system key" }, "streetname": { "type": "string", "description": "Building street name" }, "streetnameAlt": { "type": "string", "description": "Building street name in alternative language" }, "streetno": { "type": "string", "description": "Building number" }, "subdivision": { "type": "string", "description": "Building municipality subdivision" }, "updatedBy": { "type": "string", "description": "Last updater", "readOnly": true }, "updatedTs": { "type": "string", "description": "Last update date time", "format": "date-time", "readOnly": true }, "usagePurpose": { "$ref": "#/components/schemas/BuildingUsage" }, "usagePurposeAlt": { "$ref": "#/components/schemas/AddressSecondaryUsage" }, "zipcode": { "type": "string", "description": "Building zipcode" } } }, "SourceSystem": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "groupname": { "enum": [ "SOURCE_SYSTEM" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Source system" }, "ApartmentUsage": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "APARTMENT_USAGE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Apartment Usage purpose" }, "AddressSecondaryUsage": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "KN_ADDR_SPEC" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Address usage purpose" }, "ApartmentStatus": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "APARTMENT_STATUS" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Apartment status" }, "ErrorDetailsResponse": { "required": [ "details" ], "type": "object", "properties": { "details": { "type": "string", "description": "Detailed description of error" } }, "description": "Standard error response payload" }, "BuildingUsage": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "BUILDING_USAGE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Building usage purpose" } }, "responses": { "Http401": { "description": "Authentication credentials are missing or invalid", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorDetailsResponse" }, "example": { "details": "Authentication credentials were not provided" } } } } }, "securitySchemes": { "Token": { "type": "apiKey", "description": "Token issued for API consumer.", "name": "Authorization", "in": "header" } } } } ````